/*

Melody player written by S.ANANTHA NARAYANAN
SEE : www.geocities.com/anant_narayan

use 11.0592 Mhz crystal for 89c2051 refer to circuit diagram

*/


#include "at89x051.h"

const unsigned char oct0l[] = {0xFF,0x1C,0x37,0x52,0x6A,0x82,0x98,0xAD,0xC0,0xD3,0xE4,0xF5,0x01};
const unsigned char oct0h[] = {0xFD,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0x01};
const unsigned char oct1l[] = {0x04,0x13,0x21,0x2E,0x3A,0x45,0x51,0x5B,0x65,0x6E,0x77,0x7F,0x01};
const unsigned char oct1h[] = {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x01};
const unsigned char oct2l[] = {0x87,0x8E,0x95,0x9C,0xA2,0xA8,0xAD,0xB3,0xB7,0xBC,0xC0,0xC5,0x01};
const unsigned char oct2h[] = {0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x01};

const unsigned char TIMEhl[2] = {0xB0,0x17};

unsigned char time; /* delay of each note */
unsigned char delay;
unsigned char freq;
unsigned char note,songs;
unsigned char *octptrl;
unsigned char *octptrh;
bit speaker_on;


/* hall

const unsigned char SONGLINE1[] ={0xD2,0x63,0xA1,0xB0,0xD1,0xB9,0xB8,0xB9,0xD2,0xB0,0xD1,0xB8,0xA9,0xE0};
const unsigned char SONGLINE2[] ={0xD2,0xA0,0xA1,0xD1,0xA9,0xD2,0x60,0xD1,0xA9,0xD1,0xB8,0xB6,0xC8,0xD1,0x69,0xE0};
const unsigned char SONGLINE3[] ={0xD2,0xA0,0xB1,0xD1,0xB9,0xD2,0x60,0xA1,0xB3,0xD1,0xB9,0xD2,0xA0,0xA1,0xB3,0xA4,0xA6,0xE0};
const unsigned char SONGLINE4[] ={0xD2,0xB8,0xB6,0xB4,0xC3,0x63,0xA1,0xB0,0xD1,0xB9,0xB8,0xB9,0xD2,0xB0,0xD1,0xB8,0xE0};
const unsigned char SONGLINE5[] ={0xD2,0xA4,0xA4,0xA4,0xA4,0x63,0xA1,0xB0,0xD1,0xB9,0xC8,0xE0 };
*/

/* joy 

const unsigned char SONGLINE6[] ={0xD2,0xB3,0x71,0x90,0xD1,0x69,0xA8,0xB6,0xB4,0x63,0xA9,0xE0};
const unsigned char SONGLINE7[] ={0xD2,0x60,0xA0,0x61,0xA1,0xC3,0x63,0xA3,0xA3,0xA1,0xA0,0xE0};
const unsigned char SONGLINE8[] ={0xD1,0xA9,0x79,0x98,0xA6,0xD2,0xA3,0xA3,0xA1,0xA0,0xE0};
const unsigned char SONGLINE9[] ={0xD1,0xA9,0x79,0x98,0xA6,0xA6,0xA6,0xA6,0xA6,0x96,0x98,0x69,0x98,0x96,0xA4,0xA4,0xA4,0x94,0x96,0x68,0x96,0x94,0xA3,0xE0};
const unsigned char SONGLINE0[] ={0xD2,0xB3,0xA0,0xD1,0x79,0x98,0xA6,0xA8,0xB6,0xB4,0xC3,0xE0 };
*/


/*twinkle twinkle */																	  /* repeat */
const unsigned char SONGLINE1[] ={0xD1,0xB3,0xB3,0xBA,0xBA,0xD2,0xB0,0xB0,0xD1,0xCA,0xB8,0xB8,0xB7,0xB7,0xB5,0xB5,0xC3,0xE0};
const unsigned char SONGLINE2[] ={0xD1,0xBA,0xBA,0xB8,0xB8,0xB7,0xB7,0xC5,0xE0};
const unsigned char SONGGAP[]   ={0xD1,0xCC,0xE0};
/* Jingle bells */													     
const unsigned char SONGLINE3[] ={0xD1,0xB7,0xB7,0xC7,0xB7,0xB7,0xC7,0xB7,0xBA,0xB3,0xB5,0x57,0xB8,0xB8,0xB8,0xB8,0xB8,0xB7,0xB7,0xB7,0xB7,0xE0};
const unsigned char SONGLINE4[] ={0xD1,0xB7,0xB5,0xB5,0xB7,0xC5,0xE0};
const unsigned char SONGLINE5[] ={0xD1,0xBA,0xBA,0xB8,0xB5,0x53,0xE0};


const unsigned char EOSONG[] = {0xE1};
const unsigned char *song[] = {SONGLINE1,SONGLINE2,SONGLINE2,SONGLINE1,SONGGAP,SONGLINE3,SONGLINE4,SONGLINE3,SONGLINE5,SONGGAP,EOSONG};




void timer1_isr (void) interrupt 3 using 1   /* Frequency */
{
       if(speaker_on == 1) 
	P1 = ~P1;

	TL1 = octptrl[freq];
	TH1 = octptrh[freq];
	
}  
  
void timer0_isr (void) interrupt 1 using 2  /* Delay */
{

 if (time < delay)
 {
        time++;
 }
 else
 {	
	
        if(speaker_on == 1)
	{
		speaker_on = 0;
		TH0 = TIMEhl[0];	/* Set timer for 0.05 sec and *by 20 for 1sec */
		TL0 = TIMEhl[1];
		delay = 20;
		return;
	}
	else
		speaker_on = 1;

		
		
	
	if( *(song[songs] + note) == 0xE0 )
	{
		note = 0;
		songs++;
		
	}
	
	if(*(song[songs] + note) == 0xE1)
	{
	
		note = 0;
		songs = 0;
		
	}

	
	switch(*(song[songs] + note))
	{
	case 0xD0 :
		octptrl = oct0l;
		octptrh = oct0h;
		note++;
		break;
	case 0xD1:
		octptrl = oct1l;
		octptrh = oct1h;
		note++;
		break;
	case 0xD2:
		octptrl = oct2l;
		octptrh = oct2h;
		note++;
		break;
	}
	
	freq = (*(song[songs] + note) & 0x0F);
	
	if(freq == 0x0C)
		speaker_on = 0;

        	
	switch((*(song[songs] + note)) & 0xF0)
	{
		
		case 0x90:
                        delay = 4;              /*  1/16 th      */
			break;
		case 0xA0:
                        delay = 10;             /* 1/8 th       */
			break;
		case 0xB0:
                        delay = 20;             /* 1/4 th       */
			break;
		case 0xC0:
                        delay = 40;             /* 1/2 note delay */
			break;
		case 0x80:
                        delay = 6;		/* 1/16 D th */
			break;
		case 0x70:
                        delay = 12;		/* 1/8 D th */
			break;
		case 0x60:
                        delay = 26;		/* 1/4 D th */
			break;
		case 0x50:	
                        delay = 60;		/* 1/2 D th */
			break;
	}

	note++;
	time = 0;
	
 }

	TH0 = TIMEhl[0];	/* Set timer for 0.05 sec and *by 20 for 1sec */
	TL0 = TIMEhl[1];
}
void main()
{
	
	P1 = 0x00;
	note = 0;
	songs = 0;
	delay = 10;
	octptrl = oct0l;
	octptrh = oct0h;
	freq = 0;
        speaker_on = 0;


	TMOD = 0x11;	/* Set to 16 bit timers */


    PT0 = 0;  /*      SET HIGH PRIORITY TO TIMER0 */
    PT1 = 1;  
		
	ET0 = 1;	/* SET TIMER0 INTERRUPT */
	ET1 = 1;	/* SET TIMER1 INTERRUPT */
	
	
	TH0 = TIMEhl[0];	/* Set timer delay for 0.05 sec and *by 20 for 1sec */
	TL0 = TIMEhl[1];
	
	TL1 = *octptrl;
	TH1 = *octptrh;
	
	TR0 = 1;	/* run Timers */
	TR1 = 1;

	EA = 1;		/* ENABLE GLOBAL INTERRUPT */
	
	
	
	while(1);
	
}

